<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$data.puntoContacto" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Certificadores</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Certificadores</div>
      <div class="CampoOblogario">
        Consulta el desempeño de un certificador
       
      </div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <div class="CampoOblogario">
                 Certificador
              <span class="tRojo">*</span>
             </div>
            <v-autocomplete
              v-model="searchCertificador"
              :loading="isSearching"
              :items="metadata.certificadores"
              :search-input.sync="searchCertificadorSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="certificador_descripcion"
              item-value="ceco"
              @change = "getPuntoContacto()"
              placeholder="Escribe su nombre o número de empleado"
              label="Buscar Certificador"
              solo
              return-object
            />
          </v-col>
          <v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchCertificador }
              ]"
              @click="getPuntoContacto()"
              >Buscar Certificador</v-btn
            >
          </v-col>
        </v-row>
      </div>
     
      
      
     
      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">Asignación de la franquicia</div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
        
      </template>
      
    </div>
    
    
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-buscadorCertificador",
  components: {
    
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Puntos de Contacto Home",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_home_puntos_contacto"
          }
        },
        {
          text: "Gestión Puntos de Contacto",
          disabled: true
        }
      ],
      searchCertificador: null,
      searchCertificadorSync: null,
      metadata: {
        certificadores: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: []
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      isLoadingCertificadores: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      certificador: {
        id_certificador: null,
        nombre_certificador: null,
    
      }
    };
  },
  
  watch: {
    searchCertificadorSync(val) {
      if (!val) {
        this.searchCertificador = null;
        this.invokeDefaultEmpyDataCertificador();
      }
    }
  },
  computed: {
   
  },
  methods: {
    formatosByTipo(idTipoFormato) {
      return this.metadata.formatosFranquicia.filter(
        (itemFormato) => itemFormato.id_tipo_formato === idTipoFormato
      );
    },
    getPuntosContacto() {
      var self = this;
      self.isLoadingCertificadores = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/certificador")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCertificadores(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCertificadores = false;
        });
    },
    setCertificadores(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.certificador_descripcion = item.id_certificador + " - " + item.nombre_certificador;
          return item;
        });
      }
      this.metadata.certificadores = data;
    },
      
    
    getCertificador() {
      if (this.searchCertificador) {
        var self = this;
        
        self.isLoadingCertificador = true;
        axios
          .get("/punto/contacto/secure/get/" + this.searchCertificador.ceco)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
               self.infoPuntoContactoResult = true;
                if (
                  response.data.track_code &&
                  response.data.track_code === 3006
                ) {
                  self.isNotFoundPuntoContacto = true;
                  self.invokeDefaultEmpyDataCertificador();
                } else {
                  const data = response.data.data;
                  if (data) {
                    self.setPuntoContacto(data);
                    self.getDataFranquicia();
                    if (
                      self.searchCertificador &&
                      self.searchCertificador.id_estatus !== 1
                    ) {
                      self.isNoActivePuntoContacto = true;
                    }
                  }
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {
            self.isLoadingPuntoContacto = false;
          });
      }
    },
    setPuntoContacto(data) {
      data.asignacion.id_empleado = user.empleado;
      this.puntoContactoBackup = JSON.parse(JSON.stringify(data));
      this.puntoContacto = data;
    },
    cancelGlobalChanges() {
      this.puntoContacto = JSON.parse(JSON.stringify(this.puntoContactoBackup));
      this.isDialogCancel = false;
      this.$v.$reset();
    },
    saveAsignacion() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.isSavingAsignacion = true;
        axios
          .patch("/punto/contacto/secure/cu", this.puntoContacto)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                if (data) {
                  self.isDialogSave = true;
                  self.invokeDefaultEmpyDataCertificador();
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {
            self.isSavingAsignacion = false;
          });
      } else {
        this.isDialogErrorValidation = true;
      }
    },
    snapshotDataPuntoContacto() {
      let certificador = JSON.stringify(this.certificador);
      this.defaultDataPuntoContacto = JSON.parse(certificador);
    },
    invokeDefaultEmpyDataCertificador() {
      let certificador = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.certificador = certificador;
      this.$v.$reset();
    }
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getPuntosContacto();
    this.getFranquicias();
    this.getFormatosFranquicia();
  },
  
};
</script>
